package schedframe.resources.computing.description;


import java.util.ArrayList;
import java.util.List;

import schedframe.Parameters;
import schedframe.resources.ResourceType;


public abstract class ResourceDescription {

	protected String id;
	protected ResourceType type;
	protected List<ResourceDescription> children;
	protected Parameters parameters;
	
	public ResourceDescription(ResourceType type){
		this.type = type;
	}

	public List<ResourceDescription> getChildren() {
		return children;
	}
	
	public void setChildren(List<ResourceDescription> children) {
		this.children = children;
	}
	
	public void addChildren(ResourceDescription child) {
		//child.setParent(this);
		if(children == null)
			children = new ArrayList<ResourceDescription> (1);
		this.children.add(child);
	}

	public String getId(){
		return this.id;
	}

	public ResourceType getType() {
		return type;
	}
	
	public Parameters getParameters() {
		return parameters;
	}
	
	/*protected AbstractResourceDescription parent;
	/public AbstractResourceDescription getParent() {
		return parent;
	}

	public void setParent(AbstractResourceDescription parent) {
		this.parent = parent;
	}*/
	
	/*public enum ResourceType {
		COMPUTING_RESOURCE,
		QUEUING_SYSTEM;
	}
	*/
	
}
